// SocketInterface.h
#pragma once
#include <string>

class SocketInterface {
public:
    virtual ~SocketInterface() = default;
    virtual void connect(const std::string& host, unsigned short port) = 0;
    virtual void writeLine(const std::string& data) = 0;
    virtual std::string readLine() = 0;
    virtual bool canRead(double timeout) = 0;
    virtual bool isClosed() = 0;
    virtual void close() = 0;
    virtual void prepareSSL(bool incoming) = 0;
    virtual void startSSL(bool incoming) = 0;
};
